import Vue from 'vue'
import VueRouter from 'vue-router'

Vue.use(VueRouter)

const routes = [
  {
    path: '/',
    redirect: '/cargoCharts'
  },
  {
    path: '/mian',
    name: 'mian',
    // route level code-splitting
    // this generates a separate chunk (about.[hash].js) for this route
    // which is lazy-loaded when the route is visited.
    component: () => import(/* webpackChunkName: "about" */ '../views/securityCheck/index'),
    children: [
      {
        path: '/cargoCharts',
        component: () => import('@/views/securityCheck/views/cargoCharts'),
        meta: {
          title: '航空货物关联统计图'
        }
      },
      {
        path: '/cargoRelevanceTable',
        component: () => import('@/views/securityCheck/views/cargoRelevanceTable'),
        meta: {
          title: '航空货物关联统计表'
        }
      },
      {
        path: '/cargoStatistics',
        component: () => import('@/views/securityCheck/views/cargoStatisticsHome'),
        meta: {
          title: '航空货物综合统计'
        }
      },
      {
        path: '/cargoTable',
        component: () => import('@/views/securityCheck/views/cargoTable'),
        meta: {
          title: '航空货物综合统计表'
        }
      },
      {
        path: '/agent',
        component: () => import('@/views/securityCheck/views/agentHome'),
        meta: {
          title: '代理人信息统计'
        }
      },
      {
        path: '/agentTable',
        component: () => import('@/views/securityCheck/views/agentTable'),
        meta: {
          title: '代理人信息统计表'
        }
      },
      {
        path: '/securityChannel',
        component: () => import('@/views/securityCheck/views/securityChannelHome'),
        meta: {
          title: '安检通道综合效率'
        }
      },
      {
        path: '/comprehensive',
        component: () => import('@/views/securityCheck/views/comprehensiveHome'),
        meta: {
          title: '安检通道综合效率日月'
        }
      },
      {
        path: '/waybillTable',
        component: () => import('@/views/securityCheck/views/waybillTable'),
        meta: {
          title: '运单管理'
        }
      }
    ]
  }
]

const router = new VueRouter({
  mode: 'history',
  base: process.env.BASE_URL,
  routes
})

export default router
